
#include "Stream.h"
#include "StreamPrivate.h"

schar *
_s_stream_method_to_string (SStream * self);

SStream *
s_stream_new () {
  SStream * self = malloc (sizeof (SStream));
  SStreamClass * klass = malloc (sizeof (SStreamClass));
  self->priv = malloc (sizeof (SStreamPrivate));
  
  s_object_set_class (S_OBJECT (self), S_OBJECT_CLASS (klass));
  s_object_set_to_string_method (S_OBJECT (self),
                                 TO_STRING_FUNC (_s_stream_method_to_string));
  
  
  return self;
}

size_t
s_stream_get_beffered (SStream * self) {
  return self->priv->buffered;
}

schar *
_s_stream_method_to_string (SStream * self) {
  return s_string_new_fmt ("(SStream: refcount: %d, buffered: %d)",
                           s_object_get_refcount (S_OBJECT (self)),
                           s_stream_get_beffered (self));
}
