
#ifndef __H_STREAM__
#define __H_STREAM__

#include "baseobject.h"
#include "defs.h"
#include "utils.h"

/**
 * @defgroup SStream SStream
 * @addtogroup SStream
 * @{
 * @warning unimplemented.
 * @TODO
 */


typedef struct SStream SStream;
typedef struct SStreamClass SStreamClass;
typedef struct SStreamPrivate SStreamPrivate;


typedef spointer (*StreamReader)(SStream * self, size_t len);
typedef void (*StreamWriter)(SStream * self, size_t len, spointer data);

struct SStream {
  SObject parent;
  SStreamPrivate * priv;
};

struct SStreamClass {
  SObject parent_class;
  
  StreamReader reader;
  StreamWriter writer;
};

/**
 * Create a new stream.
 */
SStream *
s_stream_new ();

/**
 *
 */
size_t
s_stream_get_beffered (SStream * self);


/**
 * @}
 */

#endif /* __H_STREAM__ */
