#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdint.h>

#include "test_macros.h"
#include "refcount.h"
#include "to_string.h"
#include "error.h"
#include "dynamic_array.h"


int main  (int argc, char ** argv, char ** argp) {
  setup_suite("SSTS");
  
  test_unit (test_refcount, "Refcount");
  test_unit (test_to_string, "To String");
  test_unit (test_error, "Error");
  test_unit (test_dynamic_array, "Dynamic Array");
  
  end_suite();
}
